;==========================================================================================
; Programm mit Hilfsfunktionen fr Zeitverzgerungen
;
; Visitec GmbH Juni 2006 by N.Fritsch   	     
; 
; DataCopy.inc
;==========================================================================================
;
; DEFINIERTE ROUTINEN SIND:
;
;	DataCopy:		Durch entsprechendes setzen der Variablen CountCopy, StartVar und EndVar
;				vor Beginn des Aufrufs werden die Anzahl der Kopien, die Startpunkte
;				und die Endpunkte definiert. Die Routine kopiert dann die entsprechende Anzahl
;				in die aufeinanderfolgenden Speicherbereiche
;
;	Tab_Read:		Durch entsprechendes setzen der Variablen CountCopy, StartVar und EndVar
;				vor Beginn des Aufrufs werden die Anzahl der Kopien, die Startpunkte (Data_Tab + StartVar)
;				und die Endpunkte definiert. Die Routine kopiert dann die entsprechende Anzahl
;				in die aufeinanderfolgenden Speicherbereiche
;
; Verwendung im Hauptprogramm: 	include "DataCopy.inc"
;
; Bemerkungen:			Der Zugriff auf die Subroutinen erfolgt unter Bercksichtigung der entspechenden
;				Pages (Wo liegt die besagte Routine?; Wo luft das anschlieende Pogramm weiter?)  
;				Bsp.: mov FSR,#CountCopy
;				      mov INDF,#$05
;				      mov StartVar,#$50
;				      mov EndVar,#$70
;				      page $E00
;				           call DataCopy
;				      page $000
;
; Speicherbereich($E69-$E8D)
; Lnge ($25 = 36) Speicherwrter
;-------------------------------------------------------------------------------------------------------------
;<<<<<<<<<<<< Konfigurationen der Verbindungen zwischen AD_S825 und SX sind entsprechend anzupassen >>>>>>>>>>
	
;Variablendefinition fr DataCopy
;globale Variablen
EndVar			equ 	$0B
StartVar		equ 	$0C
HilfSpeich0		equ	$0D

;Standard Variablen
CountCopy		equ	$E3
;-------------------------------------------------------------------------------------------------------------
;<<<<<<<<<<<<<<<<<<<<<<<<< Subroutinen fr die DA Wandlung mit dem Baustein AD5324 >>>>>>>>>>>>>>>>>>>>>>>>>>>

;-Speicheradresse fr Programmcode-
org $E69	
;---------------------------------------------------------------------------

;-subroutine-
DataCopy				;call: 3Cycle/1Word
RepeatCopy				;Sprungmarke
	mov FSR,StartVar		;2Cycle/2Words
	mov HILFSREG,INDF		;2Cycle/2Words	
	mov FSR,EndVar			;2Cycle/2Words
	mov INDF,HILFSREG		;2Cycle/2Words

	INC StartVar			;1Cycle/1Word
	INC EndVar			;1Cycle/1Word

	mov FSR,#CountCopy		;2Cycle/2Words
	DEC INDF			;1Cycle/1Word
	cjne INDF,#$00,RepeatCopy	;4/6 Cycle/4Words
ret					;3Cycle/1Word

;-subroutine-
Tab_Read	;Routine zum Laden von Daten aus Tabelle
Loop_Rd
		mov w,StartVar			;2Cycle/2Words

		page $000			;1Cycle/1Word
		     call Data_Tab		;2Cycle/1Words
		page $E00			;1Cycle/1Word

		mov HilfSpeich0,w

		mov FSR,EndVar			;2Cycle/2Word
		mov INDF,HilfSpeich0			;2Cycle/2Word
		inc StartVar			;1Cycle/1Word
		inc EndVar			;1Cycle/1Word

		mov FSR,#CountCopy		;2Cycle/2Words
		DEC INDF			;1Cycle/1Word
		cjne INDF,#$00,Loop_Rd		;4/6 Cycle/4Words
ret ;($E8D)
;==========================================================================================

	