;==========================================================================================
; Programm mit Hilfsfunktionen fr Zeitverzgerungen
;
; Visitec GmbH Mai 2005 by N.Fritsch   	     
; 
; TIMER.inc
;==========================================================================================
;
; DEFINIERTE ROUTINEN SIND:
;
;	TimeEater1:		Durch entsprechendes setzen der Variable Counter vor Beginn des Aufrufs
;				wird eine entsprechende Zeitverzgerung erzeugt. Diese ist abhngig vom Prozessortakt 
;				und luft von 11*CycleTime (COUNTER = 1 => 1Durchlauf) ... 
;				11*CycleTime + 255*CycleTime (COUNTER = FF)
;
; Verwendung im Hauptprogramm: 	include "TIMER.inc"
;
; Bemerkungen:			Subroutinen sind im Programmspeicher ab Page $700 abgelegt
;				zum Zugriff auf diese Routinen ist nach dem Aufruf im Hauptprogramm 
;				wieder die entsprechende Adresse zu setzen da die ersten 3 Bits (7,6,5) 
;				des Statusregisters auf einen anderen Speicherbereich zeigen
;				des Statusregisters anzupassen in diesem Fall Page0 ==> page$000
;				Bsp.: mov FSR,#COUNTER0
;				      mov INDF,$50	
;				      page $E00
;				      call TimeEater1
;				      page $000
;
; Speicherbereich($E37-$E61)
; Lnge ($2B = 43) Speicherwrter
;-------------------------------------------------------------------------------------------------------------
;<<<<<<<<<<<< Konfigurationen der Verbindungen zwischen AD_S825 und SX sind entsprechend anzupassen >>>>>>>>>>
	
;Variablendefinition fr TIMER
COUNTER0	equ 	$E0
COUNTER1	equ 	$E1
COUNTER2	equ 	$E2
;-------------------------------------------------------------------------------------------------------------
;<<<<<<<<<<<<<<<<<<<<<<<<< Subroutinen fr die DA Wandlung mit dem Baustein AD5324 >>>>>>>>>>>>>>>>>>>>>>>>>>>

;-Speicheradresse fr Programmcode-
org $E37  
;---------------------------------------------------------------------------

;-subroutine-
TimeEater1			;3 Cycle
TE10
	mov FSR,#COUNTER0	;indirekte Adressierung (2 Cycle)
	dec INDF		;(1 Cycle)
	   jnz TE10		;(2/4 Cycle)
ret				;3 Cycle


;-subroutine-
TimeEater2
TE20
	mov FSR,#COUNTER1
	mov INDF,#$FF		;Werte fr COUNTER2 entsprechend den Erfordernissen anpassen
TE22
	mov FSR,#COUNTER1
	dec INDF
	   jnz TE22

	mov FSR,#COUNTER0
	dec INDF
	   jnz TE20
	
ret


;-subroutine-
TimeEater3
TE30	
	mov FSR,#COUNTER1
	mov INDF,#$FF		;Werte fr COUNTER2 entsprechend den Erfordernissen anpassen
TE32
	mov FSR,#COUNTER2
	mov INDF,#$E0		;Werte fr COUNTER3 entsprechend den Erfordernissen anpassen
TE33
	dec INDF		;COUNTER2 dekrementieren
	   jnz TE33

	mov FSR,#COUNTER1
	dec INDF		;COUNTER1 dekrementieren
	   jnz TE32
	
	mov FSR,#COUNTER0
	dec INDF		;COUNTER0 dekrementieren
	   jnz TE30
ret

;(Ende  $E67)
;==========================================================================================

	